//package xyz.twovb.sgm.games.impl.capturethebrick.scoreboards;
//
//import net.kyori.adventure.text.Component;
//import net.kyori.adventure.text.format.NamedTextColor;
//import net.kyori.adventure.text.format.Style;
//import net.kyori.adventure.text.format.TextDecoration;
//import net.kyori.adventure.text.minimessage.MiniMessage;
//import net.kyori.adventure.text.minimessage.tag.resolver.Placeholder;
//import net.kyori.adventure.text.minimessage.tag.resolver.TagResolver;
//import net.megavex.scoreboardlibrary.api.sidebar.Sidebar;
//import net.megavex.scoreboardlibrary.api.sidebar.component.ComponentSidebarLayout;
//import net.megavex.scoreboardlibrary.api.sidebar.component.SidebarComponent;
//import net.megavex.scoreboardlibrary.api.sidebar.component.animation.CollectionSidebarAnimation;
//import net.megavex.scoreboardlibrary.api.sidebar.component.animation.SidebarAnimation;
//import org.bukkit.plugin.Plugin;
//import org.jetbrains.annotations.NotNull;
//import xyz.twovb.sgm.games.impl.capturethebrick.CTB;
//
//import java.util.ArrayList;
//import java.util.List;
//
//public class CTBSidebar {
//    private final Sidebar sidebar;
//    private final ComponentSidebarLayout componentSidebar;
//    private final SidebarAnimation<Component> titleAnimation;
//    private final CTB minigame;
//
//    public CTBSidebar(@NotNull Plugin plugin, @NotNull Sidebar sidebar, @NotNull CTB minigame) {
//        this.sidebar = sidebar;
//        this.minigame = minigame;
//
//        this.titleAnimation = createGradientAnimation(Component.text("Capture The Brick", Style.style(TextDecoration.BOLD)));
//        var title = SidebarComponent.animatedLine(titleAnimation);
//
//        SidebarComponent gameInfo = SidebarComponent.builder()
//                .addDynamicLine(() -> Component.text("Players Alive: " + getAlivePlayersCount(), NamedTextColor.YELLOW))
//                .addDynamicLine(() -> Component.text("Red Team: " + getTeamSize(minigame.g), NamedTextColor.RED))
//                .addDynamicLine(() -> Component.text("Blue Team: " + getTeamSize(minigame.blueTeam), NamedTextColor.BLUE))
//                .addDynamicLine(() -> Component.text("Bricks Remaining: " + minigame.bricks, NamedTextColor.GREEN))
//                .build();
//
//        this.componentSidebar = new ComponentSidebarLayout(title, gameInfo);
//    }
//
//    public void onTick() {
//        titleAnimation.nextFrame();
//        componentSidebar.apply(sidebar);
//    }
//
//    private int getAlivePlayersCount() {
//        return (int) minigame.players.stream().filter(Player::isOnline).count();
//    }
//
//    private int getTeamSize(ScoreboardTeam team) {
//        return team.defaultDisplay().entries().size();
//    }
//
//    private @NotNull SidebarAnimation<Component> createGradientAnimation(@NotNull Component text) {
//        float step = 1f / 8f;
//        TagResolver.Single textPlaceholder = Placeholder.component("text", text);
//        List<Component> frames = new ArrayList<>((int) (2f / step));
//        float phase = -1f;
//        while (phase < 1) {
//            frames.add(MiniMessage.miniMessage().deserialize("<gradient:yellow:gold:" + phase + "><text>", textPlaceholder));
//            phase += step;
//        }
//        return new CollectionSidebarAnimation<>(frames);
//    }
//}
//
